routes/web.php
<?php

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::middleware(['lang'])->group(function () {

    // home page
    Route::get('/', 'HomeController@index')->name('home');
    // admin rout
    Route::group(['namespace' => 'Admin', 'prefix' => 'admin', 'as' => 'admin.'], function () {
        Route::get('login', 'LoginController@login')->name('login');
        Route::post('login', 'LoginController@loginPost')->name('loginPost');
        Route::post('logout', 'LoginController@logout')->name('logout');
        // admin check
        Route::group(['middleware' => ['auth', 'AdminCheck']], function () {
            Route::get('/', 'DashboardController@dashboard')->name('home');
            Route::get('settings', 'DashboardController@settings')->name('settings');
            Route::post('settings', 'DashboardController@settingsPost');
            Route::resources([
                'users' => 'UserController',
                'roles' => 'RoleController',
                'sliders' => 'SliderController',
                'categories' => 'CategoryController',
                'services' => 'ServiceController',
                'payments' => 'PaymentController',
                'rates' => 'RateController',
                'contacts' => 'ContactController',
                'posts' => 'PostController',
            ]);

            Route::get('activities/user/{id}', 'LoggingController@userActivities')->name('activities');
            Route::get('activities/{id}', 'LoggingController@userActivity')->name('show_activity');
    });
  });

    // vendor
    Route::group(['namespace' => 'Vendor', 'prefix' => 'vendor', 'as' => 'vendor.'], function () {
        Route::get('login', 'LoginController@login')->name('login');
        Route::post('login', 'LoginController@loginPost')->name('loginPost');;
        Route::post('logout', 'LoginController@logout')->name('logout');

        Route::group(['middleware' => ['auth', 'VendorCheck']], function () {
            Route::get('/', 'DashboardController@dashboard')->name('home');
            Route::get('settings', 'DashboardController@settings')->name('settings');
            Route::post('settings', 'DashboardController@settingsPost');
            Route::resources([
                'users' => 'UserController',
                'posts' => 'PostController',
            ]);
        });
    });

});

app/Models/Payment.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class Payment extends Model
{

    protected $fillable = [
        'name',
        'image',
        'description',
        'status',
    ];

    public function getImageAttribute($val)
    {
        return ($val != null) ? asset('storage/' . $val) : "";
    }

    public function getCreatedAtAttribute($val)
    {
        if ($val != null) {
            $M = date("M", strtotime($val));
            $d = date("d", strtotime($val));
            $Y = date("Y", strtotime($val));
            return __($M) . ' ' . $d . ', ' . $Y;
        }

    }

}

app/Http/Controllers/Admin/UserController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Models\User;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Str;

class UserController extends Controller
{
    public function __construct()
    {
        $this->middleware(['permission:users management']);
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
       $items = User:: query();
       if(request('role_id')){
          $items->whereHas('roles',function ($q){
          return $q->where('id',request('role_id'));
         });
        }
        $items = $items->paginate(10);
        if (request()->is('api/*')) {
            return response()->json($items);
        } else {
            return view('admin.users.index', compact('items'));
        }
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $users = User::get();
        return view('admin.users.add',compact('users'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {

        $validate = $request->validate([
            'first_name' => 'required|string',
            'last_name' => 'required|string',
            'mobile' => 'required',
            'email' => '',
            'image' => 'image',
            'password' => 'required',
            'note' => '',
            'logo' => 'image',
            'whatsapp' => '',
            'website' => '',
            'facebook' => '',
            'instagram' => ''
        ]);

        $validate['image'] = $request->image ? $request->image->store('courses') : "images/logo.png";
        $validate['password'] = Hash::make($request->password);

        $item =  User::create($validate);


        $item->syncRoles( $request->role_id );


        return redirect()->route('admin.users.index')->with(['success' => __("User created done")]);
    }

    /**
     * Display the specified resource.
     *
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $item = User::findOrFail($id);
        $users = User::get();
        if (request()->is('api/*')) {
            return response()->json(['item' => $item,'users' => $users]);
        } else {
            return view('admin.users.edit', compact('item','users'));
        }
    }

    /**
     * Update the specified resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $item = User::findOrFail($id);

        $validate = [];
        if ($request->has('first_name')) {
            $validate['first_name'] = $request->first_name;
        }

        if ($request->has('last_name')) {
            $validate['last_name'] = $request->last_name;
        }
        if ($request->has('mobile')) {
            $validate['mobile'] = $request->mobile;
        }
        if ($request->has('email')) {
            $validate['email'] = $request->email;
        }
        if ($request->has('image')) {
            $validate['image'] = $request->image->store('users');
        }
        if ($request->has('password')) {
            $validate['password'] = Hash::make($request->password);
        }
        if ($request->has('note')) {
            $validate['note'] = $request->note;
        }
        if ($request->status >= "0") {
            $validate['status'] = $request->status;
        }
        /* update social media */
        if ($request->has('logo')) {
            $validate['logo'] = $request->image->store('logos');
        }


        if ($request->has('whatsapp')) {
            $validate['whatsapp'] = $request->whatsapp;
        }

        if ($request->has('website')) {
            $validate['website'] = $request->website;
        }

        if ($request->has('facebook')) {
            $validate['facebook'] = $request->facebook;
        }

        if ($request->has('instagram')) {
            $validate['instagram'] = $request->instagram;
        }

        $item->update($validate);
        if (request()->is('api/*')) {
            return response()->json($item);
        } else {
            return redirect()->route('admin.users.index')->with(['success' => __("User updated done")]);
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        User::where('id',$id)->delete();
        return redirect()->route('admin.users.index')->with(['success' => __("User deleted")]);
    }

}

app/Http/Controllers/Api/UserController.php
<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use App\Models\User;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Str;

class UserController extends Controller
{


    /**
     * Store a newly created resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     * @return \Illuminate\Http\Response
     */
    public function registerPost(Request $request)
    {
        $validate = $request->validate([
            'first_name' => 'required|string',
            'last_name' => 'required|string',
            'mobile' => 'required|unique:users,mobile',
            'email' => '',
            'image' => 'image',
            'password' => 'required',
            'note' => '',
            'terms' => 'accepted',
        ]);

        $validate['image'] = $request->image ? $request->image->store('courses') : "images/logo.png";
        $validate['password'] = Hash::make($request->password);
        $user = User::create($validate);


        $user->syncRoles("Customers");

        if (!$user->token) {
            $token = $user->createToken('API');
            $user->token = $token->plainTextToken;
            $user->save();
        }

        return response()->json(['message' => 'success', "data" => $user, 'token' => $user->token]);

    }

    /**
     * Display the specified resource.
     *
     * @param Request $request
     * @return \Illuminate\Http\JsonResponse
     */
    public function loginPost(Request $request)
    {
        request()->validate([
            'mobile' => 'required|exists:users',
            'password' => 'required|min:6',
        ]);

        $credentials = request()->only('mobile', 'password');
        if (auth()->attempt($credentials)) {
            $user = User::where('id', auth()->id())->first();
            if (!$user->token) {
                $token = $user->createToken('API');
                $user->token = $token->plainTextToken;
                $user->save();
            }
            return response()->json(['message' => 'success', "data" => $user, 'token' => $user->token]);
        }
        return response()->json(['message' => __("Error in username or password")]);
    }

    /**
     * Display the specified resource.
     *
     * @param Request $request
     * @return \Illuminate\Http\JsonResponse
     */
    public function resetPasswordPost(Request $request)
    {
        request()->validate([
            'mobile' => 'required|exists:users',
        ]);

        $user = User::where('mobile', request('mobile'))->first();
        $user->code = 123456; //rand(100000,999999);
        $user->save();
        //send password here by SMS

        return response()->json(['message' => "success", "data" => $user]);
    }

    public
    function resetPasswordConfirmPost(Request $request)
    {

        request()->validate([
            'mobile' => 'required|exists:users',
            'password' => 'required|min:6|confirmed',
        ]);


        $user = User::where('id', request('mobile'))->first();
        if ($user->code != $request->code) {
            return response()->json(['message' => __("Error code")]);
        }

        $user->password = Hash::make($request->password);
        $user->save();


        return response()->json(['message' => "success", 'data' => $user]);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param int $id
     * @return \Illuminate\Http\JsonResponse
     */
    public
    function profile()
    {
        $user = User::findOrFail(auth()->id());
        return response()->json(['message' => 'success', "data" => $user]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public
    function profilePost(Request $request)
    {
        $user = User::findOrFail(auth()->id());

        $validateArray = [
            'first_name' => 'required|string',
            'last_name' => 'required|string',
            'mobile' => 'required|unique:users,mobile,' . $user->id,
            'email' => '',
            'image' => 'image',
            'note' => '',

        ];

        if ($request->has('password')) {
            $validateArray['password'] = 'required|min:6|confirmed';
        }

        $validate = $request->validate($validateArray);

        if ($request->has('first_name')) {
            $validate['first_name'] = $request->first_name;
        }
        if ($request->has('last_name')) {
            $validate['last_name'] = $request->last_name;
        }
        if ($request->has('mobile')) {
            $validate['mobile'] = $request->mobile;
        }
        if ($request->has('email')) {
            $validate['email'] = $request->email;
        }
        if ($request->has('image')) {
            $validate['image'] = $request->image->store('users');
        }
        if ($request->has('password')) {
            $validate['password'] = Hash::make($request->password);
        }
        if ($request->has('note')) {
            $validate['note'] = $request->note;
        }
        if ($request->has('status')) {
            $validate['status'] = $request->status;
        }
        $user->update($validate);

        if (!$user->token) {
            $token = $user->createToken('API');
            $user->token = $token->plainTextToken;
            $user->save();
        }

        return response()->json(['message' => 'success', "data" => $user, "token" => $user->token]);
    }
}

app/Http/Controllers/Vendor/UserController.php
<?php

namespace App\Http\Controllers\Vendor;

use App\Http\Controllers\Controller;
use App\Models\User;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Str;

class UserController extends Controller
{
    public function __construct()
    {
//        $this->middleware(['permission:personal inforamtion']);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $item = User::findOrFail($id);
        $users = User::get();
        if (request()->is('api/*')) {
            return response()->json(['item' => $item,'users' => $users]);
        } else {
            return view('vendor.users.edit', compact('item','users'));
        }
    }

    /**
     * Update the specified resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $item = User::findOrFail($id);

        $validate = [];
        if ($request->has('first_name')) {
            $validate['first_name'] = $request->first_name;
        }

        if ($request->has('last_name')) {
            $validate['last_name'] = $request->last_name;
        }
        if ($request->has('mobile')) {
            $validate['mobile'] = $request->mobile;
        }
        if ($request->has('email')) {
            $validate['email'] = $request->email;
        }
        if ($request->has('image')) {
            $validate['image'] = $request->image->store('users');
        }
        if ($request->has('password')) {
            $validate['password'] = Hash::make($request->password);
        }
        if ($request->has('note')) {
            $validate['note'] = $request->note;
        }
        if ($request->status >= "0") {
            $validate['status'] = $request->status;
        }
        /* update social media */
        if ($request->has('logo')) {
            $validate['logo'] = $request->image->store('logos');
        }


        if ($request->has('whatsapp')) {
            $validate['whatsapp'] = $request->whatsapp;
        }

        if ($request->has('website')) {
            $validate['website'] = $request->website;
        }

        if ($request->has('facebook')) {
            $validate['facebook'] = $request->facebook;
        }

        if ($request->has('instagram')) {
            $validate['instagram'] = $request->instagram;
        }

        $item->update($validate);
        if (request()->is('api/*')) {
            return response()->json($item);
        } else {
            return redirect()->route('vendor.home')->with(['success' => __("User updated done")]);
        }
    }


}

resources/views/admin/users/activities.blade.php
@extends('admin.layouts.app')
@section('title',__('Users'))
@section('content')

    <div class="row">
        <div class="col-12">
            <div class="card">
                <div class="card-header">
                    <h4 class="card-title">{{__('Users Activities')}}</h4>
                </div>

                <div class="card-content collapse show">
                    <div class="card-body card-dashboard">
                        @if($item->actions->count() > 0)
                            <div class="table-wrapper-scroll-y my-custom-scrollbar">
                                <table class="table table-striped table-bordered">
                                    <thead>
                                    <tr>
                                        <th>{{__('Id')}}</th>
                                        <th>{{__('Activity Type')}}</th>
                                        <th>{{__('Create Date')}}</th>
                                        <th>{{__('Update Date')}}</th>
                                        <th>{{__('Actions')}}</th>
                                    </tr>
                                    </thead>
                                    <tbody>
                                    @foreach($item->actions as $item)
                                        <tr>
                                            <td>{{$item->id}}</td>
                                            <td>{{$item->subject_type}} has been {{$item->description}}</td>
                                            <td>{{$item->created_at}}</td>
                                            <td>{{$item->updated_at}}</td>
                                            <td>
                                                <button class="btn btn-primary">
                                                    <a href="{{route('admin.show_activity',$item->id)}}">
                                                        <i class="icon-eye" style="color: white"></i>
                                                    </a>
                                                </button>
                                            </td>
                                        </tr>
                                    @endforeach
                                    </tbody>
                                </table>
                            </div>
                        @else
                            <h4 class="alert alert-danger text-center"> {{__('There is no items')}}</h4>
                        @endif

                    </div>
                </div>
            </div>
        </div>
    </div>

@endsection

resources/views/admin/users/activity.blade.php
@extends('admin.layouts.app')
@section('title',__('Users'))
@section('content')

    <div class="row">
        <div class="col-12">
            <div class="card">
                <div class="card-header">
                    <h4 class="card-title">{{__('Users Activities')}}</h4>
                </div>

                <div class="card-content collapse show">
                    <div class="card-body card-dashboard">

                        @if($item->description == 'updated')

                            <table class="table table-striped table-bordered" style="table-layout:fixed;">
                                <tr>
                                    <th>Attribute</th>
                                    <th>From</th>
                                    <th>To</th>
                                </tr>
                                <tbody>
                                @foreach($item->changes['attributes'] as $key => $val)
                                    @if($item->changes['attributes'][$key] != null)
                                        <tr>
                                            <td>{{$key}}</td>
                                            <td>{{ $item->changes['old'][$key] }}</td>
                                            <td>{{ $item->changes['attributes'][$key]}}</td>
                                        </tr>
                                    @endif
                                @endforeach
                                </tbody>
                            </table>

                        @elseif($item->description == 'created')

                            <table class="table table-striped table-bordered" style="table-layout:fixed;">
                                <tr>
                                    <th>Attribute</th>
                                    <th>value</th>
                                </tr>
                                <tbody>
                                @foreach($item->changes['attributes'] as $key => $val)
                                    @if($item->changes['attributes'][$key] != null)
                                        <tr>
                                            <td>{{$key}}</td>
                                            <td>{{ $item->changes['attributes'][$key]}}</td>
                                        </tr>
                                    @endif
                                @endforeach
                                </tbody>
                            </table>

                        @elseif($item->description == 'deleted')

                            <table class="table table-striped table-bordered" style="table-layout:fixed;">
                                <tr>
                                    <th>Attribute</th>
                                    <th>value</th>
                                </tr>
                                <tbody>
                                @foreach($item->changes['attributes'] as $key => $val)
                                    @if($item->changes['attributes'][$key] != null)
                                        <tr>
                                            <td>{{$key}}</td>
                                            <td>{{ $item->changes['attributes'][$key]}}</td>
                                        </tr>
                                    @endif
                                @endforeach
                                </tbody>
                            </table>

                        @endif

                    </div>
                </div>
            </div>
        </div>
    </div>

@endsection

resources/views/admin/users/index.blade.php
@extends('admin.layouts.app')
@section('title',__('Users'))
@section('content')

    <div class="row">
        <div class="col-12">
            <div class="card">
                <div class="card-header">
                    <h4 class="card-title">{{__('Users')}}</h4>
                    <a href="{{route('admin.users.create',['role_id' => request('role_id')])}}"
                       class="btn-sm btn-info block-page float-right">
                        {{__('Add user')}}
                    </a>
                </div>

                <div class="card-content collapse show">
                    <div class="card-body card-dashboard">

                        @foreach(\Spatie\Permission\Models\Role::get() as $role)
                            <a class="btn btn-info p-2 mb-2" href="{{route('admin.users.index',['role_id' => $role->id ])}}">{{$role->name}}</a>
                        @endforeach

                        @if($items->count() > 0)
                            <table class="table table-striped table-bordered">
                                <thead>
                                <tr>
                                    <th>{{__('Image')}}</th>
                                    <th>{{__('Name')}}</th>
                                    <th>{{__('Email')}}</th>
                                    <th>{{__('Mobile')}}</th>
                                    <th>{{__('Status')}}</th>
                                    <th>{{__('Control')}}</th>
                                </tr>
                                </thead>
                                <tbody>
                                @foreach($items as $item)
                                    <tr>
                                        <td>
                                            <img style="width: 150px; height: 100px;"
                                                 src="{{$item->image}}">
                                        </td>
                                        <td>{{$item->name}}</td>
                                        <td>{{$item->email}}</td>
                                        <td>{{$item->mobile}}</td>

                                        <td>{{$item->status == 1 ? __('Active') : __('Inactive')}}</td>
                                        <td>
                                            <span class="dropdown">
                                                <button id="btnSearchDrop28" type="button"
                                                        data-toggle="dropdown" aria-haspopup="true" aria-expanded="true"
                                                        class="btn btn-primary dropdown-toggle dropdown-menu-right">
                                                        <i class="icon-cog"></i></button>
                                                <span aria-labelledby="btnSearchDrop28"
                                                      class="dropdown-menu mt-1 dropdown-menu-left">
                                            <a href="{{route('admin.users.edit',$item-> id)}}"
                                               class="dropdown-item block-page">
                                                <i class="icon-pencil"></i> {{__('Edit')}}</a>
                                                  <form action="{{route('admin.users.update', $item->id)}}"
                                                        method="post">
                                                         @csrf
                                                      @method('put')
                                                      <input type="hidden" name="status"
                                                             value="{{ $item->status == 0 ?  1 : 0 }}">
                                                        <button href="#" class="dropdown-item block-page"><i
                                                                class="icon-check"></i>{{ $item->status == 0 ?  __('Active') : __('Inactive')}}</button>
                                                  </form>
                                                    <form method="post"
                                                          action="{{route('admin.users.destroy',$item-> id)}}">
                                                    @csrf
                                                        @method('DELETE')
                                                    <button class="dropdown-item block-page"><i class="icon-trash"></i>  {{__('Delete')}}</button>
                                                    </form>

                                                    <a href="{{route('admin.activities',$item-> id)}}"
                                                       class="dropdown-item block-page">
                                                <i class="icon-file-eye"></i> {{__('Show Activity')}}</a>

                                                </span>
                                             </span>
                                        </td>
                                    </tr>

                                @endforeach
                                </tbody>
                            </table>

                            {{$items->links()}}

                        @else
                            <h4 class="alert alert-danger text-center"> {{__('There is no items')}}</h4>
                        @endif
                    </div>
                </div>
            </div>
        </div>
    </div>

@endsection